﻿//---------------------------------------------------------------------------
// 串口控件演示程序，Copyright © Victor Chen

#include <fmx.h>
#pragma hdrstop

#include "UnitEnumPort.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Fmx.YbCommDevice"
#pragma resource "*.fmx"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
  AddColumn(StringGrid1, L"序号"    ,  32);
  AddColumn(StringGrid1, L"端口名称",  71);
  AddColumn(StringGrid1, L"设备别名", 255);
  AddColumn(StringGrid1, L"类型描述", 130);
  AddColumn(StringGrid1, L"类型GUID", 248);
  AddColumn(StringGrid1, L"设备标识", 157);
  AddColumn(StringGrid1, L"设备描述", 218);
  AddColumn(StringGrid1, L"位置信息", 180);
  AddColumn(StringGrid1, L"注册表的子路径", 294);

  EnumSerialPort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  EnumSerialPort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::AddColumn(TStringGrid *pGrid, UnicodeString sHeader, float fWidth)
{
  TStringColumn *clm = new TStringColumn(pGrid);
  clm->Parent = pGrid;
  clm->Header = sHeader;
  clm->Width  = fWidth;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EnumSerialPort(void)
{
  TCommSerialPortInfo spi;
  int iPortCount = spi.PortList->Count;
  StringGrid1->RowCount = iPortCount;

  for(int iPortIdx=0; iPortIdx<iPortCount; iPortIdx++)
   {
     TVictorSerialPortInfo *lpPort = spi.PortList->Ports[iPortIdx];
     int iRow = iPortIdx;
     StringGrid1->Cells[0][iRow] = IntToStr(iPortIdx+1);  // 序号
     StringGrid1->Cells[1][iRow] = lpPort->PortName;      // 端口名称
     StringGrid1->Cells[2][iRow] = lpPort->FriendlyName;  // 设备别名
     StringGrid1->Cells[3][iRow] = lpPort->ClassDesc;     // 类型描述
     StringGrid1->Cells[4][iRow] = lpPort->ClassGuid;     // 类型GUID
     StringGrid1->Cells[5][iRow] = lpPort->InstanceID;    // 设备标识
     StringGrid1->Cells[6][iRow] = lpPort->DeviceDesc;    // 设备描述
     StringGrid1->Cells[7][iRow] = lpPort->LocationInfo;  // 位置信息
     StringGrid1->Cells[8][iRow] = lpPort->RegistryPath;  // 注册表的子路径
   }
}
//---------------------------------------------------------------------------
