﻿//---------------------------------------------------------------------------
// 串口控件演示程序，Copyright © Victor Chen

#ifndef UnitSendFileH
#define UnitSendFileH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <FMX.Controls.hpp>
#include <FMX.Dialogs.hpp>
#include <FMX.Layouts.hpp>
#include <FMX.Memo.hpp>
#include <FMX.Types.hpp>
#include "Fmx.VictorFSM.h"
#include "Fmx.YbCommDevice.h"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TMemo *Memo1;
    TProgressBar *ProgressBar1;
    TButton *BtnSendFile;
    TButton *BtnSet;
    TYbCommDevice *YbCommDevice1;
    TVictorFSM *VictorFSM1;
    TOpenDialog *OpenDialog1;
    void __fastcall BtnSetClick(TObject *Sender);
    void __fastcall BtnSendFileClick(TObject *Sender);
    void __fastcall VictorFSM1ProcessState(TObject *Sender);
    void __fastcall YbCommDevice1Package(TObject *Sender, int NotifyType);
private:	// User declarations
    UnicodeString _sReceivePath;
    HANDLE _hSendFile, _hReceiveFile;
    void __fastcall ShowInfo(UnicodeString s);

    unsigned char _ucPkgID;
    unsigned char _ucTryTimes;
    long _lBytesToReceive;
    TDateTime _dtReceiveFileTime;

    UnicodeString _sUploadFileName;
    long _lUploadDataPos, _lUploadDataSize, _lUploadFileSize;
    TVictorFsmStateT<bool> _bReceivingFile;

    void ReceivePackage(TMyFinfoPkg  &finfo  );
    void ReceivePackage(TMyFdataPkg  &fdata  );
    void ReceivePackage(TMyStatusPkg &fstatus);

    void PrepareSendFile (void);
    void SendFileInfoReq (void);
    void SendFileInfoWait(void);
    void SendFileDataReq (void);
    void SendFileDataWait(void);
    void SendFileDone    (void);

    void __fastcall ShowErrDlg(const UnicodeString &sErrMsg);
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
