﻿//---------------------------------------------------------------------------
// 控件演示程序，Copyright © Victor Chen, www.cppfans.com

#ifndef UnitHangH
#define UnitHangH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.Graphics.hpp>
#include <Vcl.StdCtrls.hpp>
#include "Vcl.VictorComm.h"
//---------------------------------------------------------------------------
class TFormHang : public TForm
{
__published:	// IDE-managed Components
    TLabel *LabelPrompt;
    TTimer *TimerHang;
    TImage *Image1;
    void __fastcall TimerHangTimer(TObject *Sender);
private:	// User declarations
public:		// User declarations
    __fastcall TFormHang(TComponent* Owner);
    __fastcall ~TFormHang();

    int  __fastcall Hang(TVictorComm *lpModem, int Retries);
    void __fastcall DoHangProc(void);
    void __fastcall CheckResult(void);
    void __fastcall FinalOK(void);
    void __fastcall FinalError(void);
protected:
    TVictorComm *Modem;
    int iWhatToDo, iRetryTimes, iTotalRetries, iCloseDelay;
private:
    class TMsgStrings
     {
       public:
         enum TMsgType
          {
            MsgHang    = 0, //"挂机"
            MsgHanging = 1, //"正在挂机, 请稍候……"
            MsgCount   = 2, //=count=
          };

         __fastcall TMsgStrings();
         __property UnicodeString Msg[TMsgType] = { read = fGetMsg };

       private:
         UnicodeString __fastcall fGetMsg(TMsgType mt);

         const wchar_t **_Msg;
         static const wchar_t *_Msg_Chs[MsgCount];
         static const wchar_t *_Msg_Cht[MsgCount];
         static const wchar_t *_Msg_Enu[MsgCount];
     };
};
//---------------------------------------------------------------------------
extern PACKAGE TFormHang *FormHang;
extern int RunDialogHang(TComponent* Owner, TVictorComm *lpModem, int Retries=3);
//---------------------------------------------------------------------------
#endif
