﻿//---------------------------------------------------------------------------
// 串口控件演示程序，Copyright © Victor Chen

#ifndef UnitSendFileH
#define UnitSendFileH
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.StdCtrls.hpp>
#include "Vcl.VictorFSM.h"
#include "Vcl.YbCommDevice.h"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TYbCommDevice *YbCommDevice1;
    TBitBtn *BitBtn1;
    TProgressBar *ProgressBar1;
    TMemo *Memo1;
    TButton *ButtonSet;
    TVictorFSM *VictorFSM1;
    TOpenDialog *OpenDialog1;
    void __fastcall YbCommDevice1Package(TObject *Sender, int NotifyType);
    void __fastcall ButtonSetClick(TObject *Sender);
    void __fastcall VictorFSM1ProcessState(TObject *Sender);
    void __fastcall BitBtn1Click(TObject *Sender);
private:	// User declarations
    UnicodeString _sReceivePath;
    HANDLE _hSendFile, _hReceiveFile;
    void __fastcall ShowInfo(UnicodeString s);

    unsigned char _ucPkgID;
    unsigned char _ucTryTimes;
    long _lBytesToReceive;
    TDateTime _dtReceiveFileTime;

    UnicodeString _sUploadFileName;
    long _lUploadDataPos, _lUploadDataSize, _lUploadFileSize;
    TVictorFsmStateT<bool> _bReceivingFile;

    void ReceivePackage(TMyFinfoPkg  &finfo  );
    void ReceivePackage(TMyFdataPkg  &fdata  );
    void ReceivePackage(TMyStatusPkg &fstatus);

    void PrepareSendFile (void);
    void SendFileInfoReq (void);
    void SendFileInfoWait(void);
    void SendFileDataReq (void);
    void SendFileDataWait(void);
    void SendFileDone    (void);
public:		// User declarations
    __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
